diff --git a/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java b/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
index 5de567958..df96fb598 100644
--- a/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
+++ b/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.player.gamemode;
 
-import net.minecraft.core.player.inventory.ContainerPlayer;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -184,7 +184,7 @@ public abstract class Gamemode
 		return this;
 	}
 
-	public abstract ContainerPlayer getContainer(InventoryPlayer inventory, boolean isNotClientSide);
+	public abstract InventoryMenu getContainer(Inventory inventory, boolean isNotClientSide);
 
 	public static final Gamemode[] gamemodesList = new Gamemode[5];
 	public static List<Gamemode> getPublicGamemodes(){
diff --git a/src/main/java/net/minecraft/core/player/gamemode/GamemodeCreative.java b/src/main/java/net/minecraft/core/player/gamemode/GamemodeCreative.java
index 6fd0fedf8..60a319647 100644
--- a/src/main/java/net/minecraft/core/player/gamemode/GamemodeCreative.java
+++ b/src/main/java/net/minecraft/core/player/gamemode/GamemodeCreative.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.player.gamemode;
 
-import net.minecraft.core.player.inventory.ContainerPlayer;
-import net.minecraft.core.player.inventory.ContainerPlayerCreative;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.menu.CreativeInventoryMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 
 public class GamemodeCreative extends Gamemode
 {
@@ -13,8 +13,8 @@ public class GamemodeCreative extends Gamemode
 	}
 
 	@Override
-	public ContainerPlayer getContainer(InventoryPlayer inventory, boolean isNotClientSide)
+	public InventoryMenu getContainer(Inventory inventory, boolean isNotClientSide)
 	{
-		return new ContainerPlayerCreative(inventory, isNotClientSide);
+		return new CreativeInventoryMenu(inventory, isNotClientSide);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/player/gamemode/GamemodeSurvival.java b/src/main/java/net/minecraft/core/player/gamemode/GamemodeSurvival.java
index 5661f2944..905892c68 100644
--- a/src/main/java/net/minecraft/core/player/gamemode/GamemodeSurvival.java
+++ b/src/main/java/net/minecraft/core/player/gamemode/GamemodeSurvival.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.player.gamemode;
 
-import net.minecraft.core.player.inventory.ContainerPlayer;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 
 public class GamemodeSurvival extends Gamemode
 {
@@ -12,8 +12,8 @@ public class GamemodeSurvival extends Gamemode
 	}
 
 	@Override
-	public ContainerPlayer getContainer(InventoryPlayer inventory, boolean isNotClientSide)
+	public InventoryMenu getContainer(Inventory inventory, boolean isNotClientSide)
 	{
-		return new ContainerPlayer(inventory, isNotClientSide);
+		return new InventoryMenu(inventory, isNotClientSide);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/CompoundContainer.java b/src/main/java/net/minecraft/core/player/inventory/container/CompoundContainer.java
new file mode 100644
index 000000000..a70b6ad7a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/container/CompoundContainer.java
@@ -0,0 +1,103 @@
+package net.minecraft.core.player.inventory.container;
+
+
+// Referenced classes of package net.minecraft.src:
+//            IInventory, ItemStack, Player
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.InventorySorter;
+
+public class CompoundContainer
+    implements Container
+{
+    private String name;
+    private Container c1;
+    private Container c2;
+
+    public CompoundContainer(String s, Container c1, Container c2)
+    {
+        name = s;
+        this.c1 = c1;
+        this.c2 = c2;
+    }
+
+    @Override
+	public int getContainerSize()
+    {
+        return c1.getContainerSize() + c2.getContainerSize();
+    }
+
+    @Override
+	public String getName()
+    {
+        return name;
+    }
+
+    @Override
+	public ItemStack getItem(int index)
+    {
+        if(index >= c1.getContainerSize())
+        {
+            return c2.getItem(index - c1.getContainerSize());
+        } else
+        {
+            return c1.getItem(index);
+        }
+    }
+
+    @Override
+	public ItemStack removeItem(int index, int takeAmount)
+    {
+        if(index >= c1.getContainerSize())
+        {
+            return c2.removeItem(index - c1.getContainerSize(), takeAmount);
+        } else
+        {
+            return c1.removeItem(index, takeAmount);
+        }
+    }
+
+    @Override
+	public void setItem(int index, ItemStack itemstack)
+    {
+        if(index >= c1.getContainerSize())
+        {
+            c2.setItem(index - c1.getContainerSize(), itemstack);
+        } else
+        {
+            c1.setItem(index, itemstack);
+        }
+    }
+
+    @Override
+	public int getMaxStackSize()
+    {
+        return c1.getMaxStackSize();
+    }
+
+    @Override
+	public void setChanged()
+    {
+        c1.setChanged();
+        c2.setChanged();
+    }
+
+    @Override
+	public boolean stillValid(Player entityplayer)
+    {
+        return c1.stillValid(entityplayer) && c2.stillValid(entityplayer);
+    }
+
+    @Override
+    public void sortContainer() {
+        ItemStack[] itemStacks = new ItemStack[getContainerSize()];
+        for (int i = 0; i < itemStacks.length; i++) {
+            itemStacks[i] = getItem(i);
+        }
+        InventorySorter.sortInventory(itemStacks);
+        for (int i = 0; i < itemStacks.length; i++) {
+            setItem(i, itemStacks[i]);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/Container.java b/src/main/java/net/minecraft/core/player/inventory/container/Container.java
new file mode 100644
index 000000000..e88398b1a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/container/Container.java
@@ -0,0 +1,30 @@
+package net.minecraft.core.player.inventory.container;
+
+
+// Referenced classes of package net.minecraft.src:
+//            ItemStack, Player
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+
+public interface Container
+{
+
+    int getContainerSize();
+
+    ItemStack getItem(int index);
+
+    ItemStack removeItem(int index, int takeAmount);
+
+    void setItem(int index, ItemStack itemstack);
+
+    String getName();
+
+    int getMaxStackSize();
+
+    void setChanged();
+
+    boolean stillValid(Player entityplayer);
+
+    void sortContainer();
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/CraftingContainer.java b/src/main/java/net/minecraft/core/player/inventory/container/CraftingContainer.java
new file mode 100644
index 000000000..be1d4a537
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/container/CraftingContainer.java
@@ -0,0 +1,128 @@
+package net.minecraft.core.player.inventory.container;
+
+
+// Referenced classes of package net.minecraft.src:
+//            IInventory, ItemStack, Container, Player
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
+
+public class CraftingContainer
+    implements Container
+{
+    private ItemStack[] items;
+    private int width;
+    private AbstractContainerMenu menu;
+
+    public CraftingContainer(AbstractContainerMenu container, int width, int n)
+    {
+        int k = width * n;
+        items = new ItemStack[k];
+        menu = container;
+        this.width = width;
+    }
+
+    @Override
+	public int getContainerSize()
+    {
+        return items.length;
+    }
+
+    @Override
+	public ItemStack getItem(int index)
+    {
+        if(index >= getContainerSize())
+        {
+            return null;
+        } else
+        {
+            return items[index];
+        }
+    }
+
+    public ItemStack getItemStackAt(int i, int j)
+    {
+        if(i < 0 || i >= width)
+        {
+            return null;
+        } else
+        {
+            int k = i + j * width;
+            return getItem(k);
+        }
+    }
+
+    public void setSlotContentsAt(int i, int j, ItemStack itemStack)
+    {
+        if(i < 0 || i >= width)
+        {
+            return;
+        } else
+        {
+            int k = i + j * width;
+            setItem(k, itemStack);
+        }
+    }
+
+    @Override
+	public String getName()
+    {
+        return "Crafting";
+    }
+
+    @Override
+	public ItemStack removeItem(int index, int takeAmount)
+    {
+        if(items[index] != null)
+        {
+            if(items[index].stackSize <= takeAmount)
+            {
+                ItemStack itemstack = items[index];
+                items[index] = null;
+                menu.slotsChanged(this);
+                return itemstack;
+            }
+            ItemStack itemstack1 = items[index].splitStack(takeAmount);
+            if(items[index].stackSize <= 0)
+            {
+                items[index] = null;
+            }
+            menu.slotsChanged(this);
+            return itemstack1;
+        } else
+        {
+            return null;
+        }
+    }
+
+    @Override
+	public void setItem(int index, ItemStack itemstack)
+    {
+        items[index] = itemstack;
+        menu.slotsChanged(this);
+    }
+
+    @Override
+	public int getMaxStackSize()
+    {
+        return 64;
+    }
+
+    @Override
+	public void setChanged()
+    {
+        menu.slotsChanged(this);
+    }
+
+    @Override
+	public boolean stillValid(Player entityplayer)
+    {
+        return true;
+    }
+
+    @Override
+    public void sortContainer() {
+        // Do nothing
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
similarity index 82%
rename from src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
rename to src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
index f23e1b4ce..53abeeead 100644
--- a/src/main/java/net/minecraft/core/player/inventory/InventoryPlayer.java
+++ b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.container;
 
 
 import com.mojang.nbt.CompoundTag;
@@ -7,25 +7,27 @@ import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
 
 // Referenced classes of package net.minecraft.src:
-//            IInventory, ItemStack, EntityPlayer, NBTTagCompound, 
-//            NBTTagList, Block, Material, ItemArmor, 
+//            IInventory, ItemStack, Player, NBTTagCompound,
+//            NBTTagList, Block, Material, ArmorItem,
 //            Entity
 
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
 import org.jetbrains.annotations.Nullable;
 
-public class InventoryPlayer
-    implements IInventory
+public class Inventory
+    implements Container
 {
 
-    public InventoryPlayer(EntityPlayer player)
+    public Inventory(Player player)
     {
         mainInventory = new ItemStack[36];
         armorInventory = new ItemStack[4];
@@ -72,7 +74,7 @@ public class InventoryPlayer
                     mainInventory[i].itemID == itemstack.itemID &&
                     mainInventory[i].isStackable() &&
                     mainInventory[i].stackSize < mainInventory[i].getMaxStackSize() &&
-                    mainInventory[i].stackSize < getInventoryStackLimit() &&
+                    mainInventory[i].stackSize < getMaxStackSize() &&
                     (!mainInventory[i].getHasSubtypes() || mainInventory[i].getMetadata() == itemstack.getMetadata())
             )
             {
@@ -201,26 +203,26 @@ public class InventoryPlayer
     }
     
     @Override
-	public ItemStack decrStackSize(int i, int j)
+	public ItemStack removeItem(int index, int takeAmount)
     {
         ItemStack aitemstack[] = mainInventory;
-        if(i >= mainInventory.length)
+        if(index >= mainInventory.length)
         {
             aitemstack = armorInventory;
-            i -= mainInventory.length;
+            index -= mainInventory.length;
         }
-        if(aitemstack[i] != null)
+        if(aitemstack[index] != null)
         {
-            if(aitemstack[i].stackSize <= j)
+            if(aitemstack[index].stackSize <= takeAmount)
             {
-                ItemStack itemstack = aitemstack[i];
-                aitemstack[i] = null;
+                ItemStack itemstack = aitemstack[index];
+                aitemstack[index] = null;
                 return itemstack;
             }
-            ItemStack itemstack1 = aitemstack[i].splitStack(j);
-            if(aitemstack[i].stackSize <= 0)
+            ItemStack itemstack1 = aitemstack[index].splitStack(takeAmount);
+            if(aitemstack[index].stackSize <= 0)
             {
-                aitemstack[i] = null;
+                aitemstack[index] = null;
             }
             return itemstack1;
         } else
@@ -230,15 +232,15 @@ public class InventoryPlayer
     }
 
     @Override
-	public void setInventorySlotContents(int i, ItemStack itemstack)
+	public void setItem(int index, ItemStack itemstack)
     {
         ItemStack aitemstack[] = mainInventory;
-        if(i >= aitemstack.length)
+        if(index >= aitemstack.length)
         {
-            i -= aitemstack.length;
+            index -= aitemstack.length;
             aitemstack = armorInventory;
         }
-        aitemstack[i] = itemstack;
+        aitemstack[index] = itemstack;
     }
 
     public float getStrVsBlock(Block block)
@@ -304,38 +306,38 @@ public class InventoryPlayer
     }
 
     @Override
-	public int getSizeInventory()
+	public int getContainerSize()
     {
         return mainInventory.length + 4;
     }
 
     @Override
-	public ItemStack getStackInSlot(int i)
+	public ItemStack getItem(int index)
     {
         ItemStack aitemstack[] = mainInventory;
-        if(i >= aitemstack.length)
+        if(index >= aitemstack.length)
         {
-            i -= aitemstack.length;
+            index -= aitemstack.length;
             aitemstack = armorInventory;
         }
-        return aitemstack[i];
+        return aitemstack[index];
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "Inventory";
     }
 
     @Override
-	public int getInventoryStackLimit()
+	public int getMaxStackSize()
     {
         return 64;
     }
 
     public int getDamageVsEntity(Entity entity)
     {
-        ItemStack itemstack = getStackInSlot(currentItem);
+        ItemStack itemstack = getItem(currentItem);
         if(itemstack != null)
         {
             return itemstack.getDamageVsEntity(entity);
@@ -352,7 +354,7 @@ public class InventoryPlayer
         {
             return true;
         }
-        ItemStack itemstack = getStackInSlot(currentItem);
+        ItemStack itemstack = getItem(currentItem);
         if(itemstack != null)
         {
             return itemstack.canHarvestBlock(player, block);
@@ -373,8 +375,8 @@ public class InventoryPlayer
     	
     	for(int armorPiece=0; armorPiece < armorInventory.length; armorPiece++) {
     		ItemStack itemStack = armorInventory[armorPiece];
-    		if(itemStack != null && itemStack.getItem() instanceof ItemArmor) {
-    			ItemArmor armor = (ItemArmor) itemStack.getItem();
+    		if(itemStack != null && itemStack.getItem() instanceof IArmorItem) {
+                Item armor = itemStack.getItem();
     			
     			maxDurability += armor.getMaxDamage();
     			armorDurability += armor.getMaxDamage() - itemStack.getMetadata();
@@ -386,14 +388,16 @@ public class InventoryPlayer
 
     public float getTotalProtectionAmount(DamageType damageType) {
     	float protectionPercentage = 0.0f;
-    	
-    	for(int i=0; i < armorInventory.length; i++) {
-			if(armorInventory[i] != null && armorInventory[i].getItem() instanceof ItemArmor) {
-				ItemArmor armor = (ItemArmor) armorInventory[i].getItem();
-				
-				protectionPercentage += armor.material.getProtection(damageType) * armor.getArmorPieceProtectionPercentage();
-			}
-    	}
+
+        for (ItemStack itemStack : armorInventory) {
+            if (itemStack != null && itemStack.getItem() instanceof IArmorItem) {
+                IArmorItem armor = (IArmorItem) itemStack.getItem();
+                ArmorMaterial material = armor.getArmorMaterial();
+                if (material != null) {
+                    protectionPercentage += material.getProtection(damageType) * armor.getArmorPieceProtectionPercentage();
+                }
+            }
+        }
     	
     	return protectionPercentage;
     }
@@ -402,7 +406,7 @@ public class InventoryPlayer
     {
         for(int j = 0; j < armorInventory.length; j++)
         {
-            if(armorInventory[j] == null || !(armorInventory[j].getItem() instanceof ItemArmor))
+            if(armorInventory[j] == null || !(armorInventory[j].getItem() instanceof IArmorItem))
             {
                 continue;
             }
@@ -451,7 +455,7 @@ public class InventoryPlayer
     }
 
     @Override
-	public void onInventoryChanged()
+	public void setChanged()
     {
         inventoryChanged = true;
     }
@@ -469,7 +473,7 @@ public class InventoryPlayer
     }
 
     @Override
-	public boolean canInteractWith(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
         if(player.removed)
         {
@@ -500,19 +504,19 @@ public class InventoryPlayer
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         InventorySorter.sortInventory(mainInventory, 9, mainInventory.length - 1);
     }
 	
-	public void transferAllContents(InventoryPlayer inventoryPlayer) {
+	public void transferAllContents(Inventory inventory) {
 		for(int i=0; i < mainInventory.length; i++) {
-			this.mainInventory[i] = inventoryPlayer.mainInventory[i];
-			inventoryPlayer.mainInventory[i] = null;
+			this.mainInventory[i] = inventory.mainInventory[i];
+			inventory.mainInventory[i] = null;
 		}
 		
 		for(int i=0; i < armorInventory.length; i++) {
-			this.armorInventory[i] = inventoryPlayer.armorInventory[i];
-			inventoryPlayer.armorInventory[i] = null;
+			this.armorInventory[i] = inventory.armorInventory[i];
+			inventory.armorInventory[i] = null;
 		}
 	}
 
@@ -520,7 +524,7 @@ public class InventoryPlayer
     public ItemStack[] mainInventory;
     public ItemStack[] armorInventory;
     public int currentItem;
-    public EntityPlayer player;
+    public Player player;
     private ItemStack heldItem;
     public boolean inventoryChanged;
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/ResultContainer.java b/src/main/java/net/minecraft/core/player/inventory/container/ResultContainer.java
new file mode 100644
index 000000000..db8a365c0
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/container/ResultContainer.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.player.inventory.container;
+
+
+// Referenced classes of package net.minecraft.src:
+//            IInventory, ItemStack, Player
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+
+public class ResultContainer
+    implements Container
+{
+    private ItemStack[] items;
+
+    public ResultContainer()
+    {
+        items = new ItemStack[1];
+    }
+
+    @Override
+	public int getContainerSize()
+    {
+        return 1;
+    }
+
+    @Override
+	public ItemStack getItem(int index)
+    {
+        return items[index];
+    }
+
+    @Override
+	public String getName()
+    {
+        return "Result";
+    }
+
+    @Override
+	public ItemStack removeItem(int index, int takeAmount)
+    {
+        if(items[index] != null)
+        {
+            ItemStack itemstack = items[index];
+            items[index] = null;
+            return itemstack;
+        } else
+        {
+            return null;
+        }
+    }
+
+    @Override
+	public void setItem(int index, ItemStack itemstack)
+    {
+        items[index] = itemstack;
+    }
+
+
+    @Override
+	public int getMaxStackSize()
+    {
+        return 64;
+    }
+
+    @Override
+	public void setChanged()
+    {
+    }
+
+    @Override
+	public boolean stillValid(Player entityplayer)
+    {
+        return true;
+    }
+
+    @Override
+    public void sortContainer() {
+        // Do nothing
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/SimpleContainer.java b/src/main/java/net/minecraft/core/player/inventory/container/SimpleContainer.java
new file mode 100644
index 000000000..f4a0eae9c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/player/inventory/container/SimpleContainer.java
@@ -0,0 +1,99 @@
+package net.minecraft.core.player.inventory.container;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.InventorySorter;
+
+// Referenced classes of package net.minecraft.src:
+//            IInventory, ItemStack, IInvBasic, Player
+
+public class SimpleContainer
+    implements Container
+{
+    private String name;
+    private int size;
+    private ItemStack[] items;
+
+    public SimpleContainer(String name, int size)
+    {
+        this.name = name;
+        this.size = size;
+        items = new ItemStack[size];
+    }
+
+    @Override
+	public ItemStack getItem(int index)
+    {
+        return items[index];
+    }
+
+    @Override
+	public ItemStack removeItem(int index, int takeAmount)
+    {
+        if(items[index] != null)
+        {
+            if(items[index].stackSize <= takeAmount)
+            {
+                ItemStack itemstack = items[index];
+                items[index] = null;
+                setChanged();
+                return itemstack;
+            }
+            ItemStack itemstack1 = items[index].splitStack(takeAmount);
+            if(items[index].stackSize <= 0)
+            {
+                items[index] = null;
+            }
+            setChanged();
+            return itemstack1;
+        } else
+        {
+            return null;
+        }
+    }
+
+    @Override
+	public void setItem(int index, ItemStack itemstack)
+    {
+        items[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
+        {
+            itemstack.stackSize = getMaxStackSize();
+        }
+        setChanged();
+    }
+
+    @Override
+	public int getContainerSize()
+    {
+        return size;
+    }
+
+    @Override
+	public String getName()
+    {
+        return name;
+    }
+
+    @Override
+	public int getMaxStackSize()
+    {
+        return 64;
+    }
+
+    @Override
+	public void setChanged()
+    {
+    }
+
+    @Override
+	public boolean stillValid(Player entityplayer)
+    {
+        return true;
+    }
+
+    @Override
+    public void sortContainer() {
+        InventorySorter.sortInventory(items);
+    }
+}
